/*
 * Copyright (c) 2022 Eclipse Foundation, Inc.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * Contributors:
 *   Olivier Goulet <olivier.goulet@eclipse-foundation.org>
 *
 * SPDX-License-Identifier: EPL-2.0
 */

import 'isomorphic-fetch';
import { playlistMapping } from '../../eclipsefdn.media-link';

const playlistFromAPI = {
  id: 'PLy7t4z5SYNaTxmWWrnLYshYKaSLhRKNk-',
  etag: 'GIlt1wmWmIlDvAhso8A6Q0cOs1o',
  snippet: {
    published_at: '2022-12-08T08:36:42Z',
    channel_id: 'UCej18QqbZDxuYxyERPgs2Fw',
    title: 'Celebrating Theia 5th Anniversary',
    thumbnails: {
      medium: {
        url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/mqdefault.jpg',
        width: 320,
        height: 180,
      },
      high: {
        url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/hqdefault.jpg',
        width: 480,
        height: 360,
      },
      standard: {
        url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/sddefault.jpg',
        width: 640,
        height: 480,
      },
      maxres: {
        url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/maxresdefault.jpg',
        width: 1280,
        height: 720,
      },
      default: {
        url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/default.jpg',
        width: 120,
        height: 90,
      },
    },
    channel_title: 'Eclipse Foundation',
    localized: {
      title: 'Celebrating Theia 5th Anniversary',
      description: '',
    },
    description: '',
  },
  player: {
    embed_html:
      '<iframe width="640" height="360" src="http://www.youtube.com/embed/videoseries?list=PLy7t4z5SYNaTxmWWrnLYshYKaSLhRKNk-" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>',
  },
};

const mappedPlaylist = {
    id: 'PLy7t4z5SYNaTxmWWrnLYshYKaSLhRKNk-',
    title: 'Celebrating Theia 5th Anniversary',
    description: '',
    publishedAt: '2022-12-08T08:36:42Z',
    thumbnails:  {
        medium: {
            url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/mqdefault.jpg',
            width: 320,
            height: 180,
            },
            high: {
            url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/hqdefault.jpg',
            width: 480,
            height: 360,
            },
            standard: {
            url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/sddefault.jpg',
            width: 640,
            height: 480,
            },
            maxres: {
            url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/maxresdefault.jpg',
            width: 1280,
            height: 720,
            },
            default: {
            url: 'https://i.ytimg.com/vi/Th1pC-yT1Ac/default.jpg',
            width: 120,
            height: 90,
            }
    },
    channelId: 'UCej18QqbZDxuYxyERPgs2Fw',
    channelTitle: 'Eclipse Foundation',
    player: {
        embedHtml: '<iframe width="640" height="360" src="http://www.youtube.com/embed/videoseries?list=PLy7t4z5SYNaTxmWWrnLYshYKaSLhRKNk-" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>',
    }
}

describe('Media Link API', () => {
  it('Maps playlist keys from API to model', () => {
    const expected = mappedPlaylist;
    const result = playlistMapping(playlistFromAPI);

    expect(result).toMatchObject(expected);
  });

});
